plantUML DSL - Bug #1972

Composite state transitions are displayed erronous

09/01/2014 04:24 PM - N. Koster
Description

The state which is transitioned to after a composite state is always included within the composite state itself (see image)

@startuml
title example
[]--> st
state s1

s1 --> composite_s1
state composite_s1 {

state sub_s1

sub_s1 --> external_s2

}

state external_s2
@enduml

Leads to:

example

( composite_s1 A
external_s2
LS .

however, a different plantuml syntax (moving the following state before the composite state) created the correct image:

@startuml
title example
[¥] --> s1

state s1

s1 --> composite_s1
state external_s2

state composite_s1 {
state sub_s1

sub_s1 --> external_s2

1
@enduml

Leads to:

example

__/

( composite_sl W

[ external_s2 ]

So, should we adjust the DSL to work with this?

Associated revisions

Revision f5d294da - 05/19/2015 08:56 PM - Arne Nordmann

Migration to 3.2 and fixes

- Composite states now can have compartments

- Introduced external transition with explicit source and target

refs #1972
refs #2054

History

#1 - 09/01/2014 06:40 PM - S. Wrede

This seems to be a bug in the plantUML renderer. Rendering all top-level states at the top of the file and all transitions at the end of the file should
help. This can be enforced in the generator implementation.
#2 - 09/01/2014 06:45 PM - S. Wrede
- File rendering-error-2.png added
- File rendering-error-2.png added

Even worse the following

@startuml

title example

[*] -> s1

state s1

s1 --> composite_s1
state external_s2
external_s2 --> sub_s1
state composite_s1 {
state sub_s1

sub_s1 --> external_s2

}
@enduml

leads to the following diagram:

example

external_s2

2

[ composite_s1 '|

#3 - 10/10/2014 12:03 PM - N. Késter
- Priority changed from Normal to High

The Isp-csra kitchen scenario plantuml is also affected by this. Moving transitions at the bottom solves this issue. Its quite important, as all rendered
images which include composite states have those errors and need to be modified by hand.

#4 - 07/04/2016 10:27 PM - S. Wrede
- Assignee changed from S. Wrede to P. Holthaus

- Target version set to Language Refactoring
Is this still a problem?

#5 - 07/04/2016 10:31 PM - S. Wrede

This seems to be fixed in master. See solution Test, Model Issue1972.
